<?php
/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoAppendArticlePage
 * A function to append a new article page
 * @author Philipp Louis Esselbach
 */
function AdminDoAppendArticlePage()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $words_articles;
	$input_article_pagetitle = ( isset( $_POST[ 'input_article_pagetitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_pagetitle' ] ) : "" ;
	$input_article_pagetext = ( isset( $_POST[ 'input_article_pagetext' ] ) ) ? $security -> checkvar( $_POST[ 'input_article_pagetext' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_title' ] ) : "" ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_description' ] ) : "" ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_zid = ( isset( $_POST[ 'input_zid' ] ) ) ? $security -> checknum( $_POST[ 'input_zid' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;

	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_articles[ 'ERROR' ], $words_articles[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_doupload )
	{
		$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ] : "" ;
		$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$notice = $words_articles[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_articles[ 'BYTES' ];
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$notice = $words_articles[ 'FILETYPE_INVALID' ];
			}
		}
		else
		{
			$notice = $words_articles[ 'FILETYPE_UNKNOWN' ];
		}
		
		if( !$tmp_name )
		{
			$notice = $words_articles[ 'FILE_EMPTY' ];
		}
		
		if( !$notice )
		{
			$file = @fopen( $tmp_name, "r" );
			
			if( $file )
			{
				$binary = fread( $file, filesize( $tmp_name ) );
				
				if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
				{
					if( $preferences[ 'articles_image_width' ] )
					{
						$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'articles_image_width' ], $preferences[ 'articles_image_brandtext' ], $preferences[ 'articles_image_brandcolor' ] );
						$file_size = strlen( $binary );
					}
					
					$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'articles_image_thumbwidth' ], "", "" );
					$thumb_size = strlen( $thumb_image );
					$thumb_image = $database -> dbescape( $thumb_image );
				}
				else
				{
					$thumb_image = "";
					$thumb_size = 0;
				}
				
				$binary = $database -> dbescape( $binary );
				fclose( $file );
				
				if( !$input_file_title )
				{
					$input_file_title = $file_name;
				}
				
				if( !$input_file_description )
				{
					$input_file_description = $words_articles[ 'NO_DESCRIPTION' ];
				}
				
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlesfiles (articlefile_id, articlefile_author, articlefile_filename, articlefile_title, articlefile_description, articlefile_mime, articlefile_size, articlefile_binary, articlefile_thumbsize, articlefile_thumbimage, articlefile_inuse, articlefile_page, articlefile_date, articlefile_views, articlefile_activity, articlefile_postip, articlefile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title . "', '" . $input_file_description . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '0', '0', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
				$notice = $words_articles[ 'UPLOAD_SUCCESSFULLY' ];
			}
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_articlesfiles WHERE articlefile_author = '" . $login_username . "' AND articlefile_id = '" . $input_file . "'" );
		$notice = $words_articles[ 'FILE_REMOVED' ];
	}
	
	$query = $database -> dbquery( "SELECT articlepage_id FROM " . DB_PREFIX . "esselbach_ct_articlespages WHERE articlepage_id = '" . $input_zid . "'" );
	
	if( !$database -> dbrows( $query ) )
	{
		$notice = $words_articles[ 'INVALID_ARTICLE' ];
	}
	
	if( !$notice )
	{
		if( !$input_article_pagetext )
		{
			$notice = $words_articles[ 'ARTICLE_NO_TEXT' ];
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT articlefile_filename FROM " . DB_PREFIX . "esselbach_ct_articlesfiles WHERE articlefile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_articles[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlesfiles SET articlefile_title = '" . $input_edittitle . "', articlefile_description = '" . $input_editdescription . "', articlefile_editip = '" . $ipaddr . "' WHERE articlefile_author = '" . $login_username . "' AND articlefile_id = '" . $input_editid . "'" );
		$notice = $words_articles[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( $input_dospellcheck )
	{
		$dictionary = pspell_new( $preferences[ 'website_spellchecker' ] );
		$words_array = explode( " ", $input_article_pagetext );
		$input_page_spelling = "";
		$input_spell_errors = 0;
		
		foreach( $words_array as $word )
		{
			if( pspell_check( $dictionary, $word ) )
			{
				$input_page_spelling .= $word . " ";
			}
			else
			{
				$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
				( $suggestions ) ? $suggestions = $words_articles[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_articles[ 'NO_SUGGESTIONS' ];
				$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
				$input_spell_errors++;
			}
			
			$input_page_spelling .= $word . " ";
		}
		
		$notice = $words_articles[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_articles[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
	}
	
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminAppendArticlePage( $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		$query = $database -> dbquery( "SELECT a1.article_id, a1.article_html, a1.article_smilies, a1.article_code, a2.articlepage_page FROM " . DB_PREFIX . "esselbach_ct_articles a1, " . DB_PREFIX . "esselbach_ct_articlespages a2 WHERE a2.articlepage_article = a1.article_id AND a2.articlepage_id = '" . $input_zid . "'" );
		list( $articleid, $input_html, $input_smilies, $input_blockcode, $articlepage ) = $database -> dbrow( $query );
		
		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_article_pagetext = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_article_pagetext );
			}
				
			if ( $input_url_get )
			{
				$input_article_pagetext = $system -> geturltitles( $input_article_pagetext );
			}
		}
		
		$input_article_pagetext_parsed = stripslashes( $input_article_pagetext );
		
		if( !$input_html )
		{
			$input_article_pagetext_parsed = $system -> dechomp( $input_article_pagetext_parsed );
		}
		
		if( $input_smilies )
		{
			$input_article_pagetext_parsed = $system -> smilies( $input_article_pagetext_parsed );
		}
		
		if( $input_blockcode )
		{
			$input_article_pagetext_parsed = $system -> code( $input_article_pagetext_parsed );
			$input_article_pagetext_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=articles&amp;action=file&amp;id=\\1\">\\2</a>", $input_article_pagetext_parsed );
			$input_article_pagetext_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=articles&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_article_pagetext_parsed );
			$input_article_pagetext_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "articles" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_articles[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=articles&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_article_pagetext_parsed );
		}
		
		$input_article_pagetext_parsed = $database -> dbescape( $input_article_pagetext_parsed );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articles SET article_pages = article_pages + 1 WHERE article_id = '" . $articleid . "'" );
		$query = $database -> dbquery( "SELECT articlepage_id, articlepage_page FROM " . DB_PREFIX . "esselbach_ct_articlespages WHERE articlepage_article = '" . $articleid . "' AND articlepage_page > '" . $articlepage . "'" );
		
		while( list( $id, $oldpage ) = $database -> dbrow( $query ) )
		{
			$newpage = $oldpage + 1;
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlespages SET articlepage_page = '" . $newpage . "' WHERE articlepage_id = '" . $id . "'" );
		}
		
		$input_article_page = $articlepage + 1;
		$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlespages (articlepage_id, articlepage_article, articlepage_page, articlepage_title, articlepage_rawtext, articlepage_text, articlepage_postip, articlepage_editip, articlepage_editadmin) VALUES (NULL, '" . $articleid . "', '" . $input_article_page . "', '" . $input_article_pagetitle . "', '" . $input_article_pagetext . "', '" . $input_article_pagetext_parsed . "', '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlesfiles SET articlefile_inuse = '1', articlefile_page = '" . $input_article_page . "', articlefile_activity = now(), articlefile_editip = '" . $ipaddr . "' WHERE articlefile_author = '" . $login_username . "' AND articlefile_inuse = '0'" );
		$html -> login( $words_articles[ 'APPEND_NEW_PAGE' ], $words_articles[ 'PAGE_SUCCESSFULLY_APPENDED' ], "index.php?action=managearticles&amp;opts=editarticle-" . $articleid );
	}
}
?>