<?php
/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminDoCheckPADUpdates
 * A function to check for PAD updates
 * @author Philipp Louis Esselbach
 */
function AdminDoCheckPADUpdates()
{
	global $database, $security, $system, $html, $ipaddr, $login_username, $preferences, $uwrapper, $words_files;
	$input_id = ( isset( $_POST[ 'input_id' ] ) ) ? $security -> checknum( $_POST[ 'input_id' ] ) : "" ;
	$input_website = ( isset( $_POST[ 'input_website' ] ) ) ? $security -> checknum( $_POST[ 'input_website' ] ) : "" ;
	$input_category = ( isset( $_POST[ 'input_category' ] ) ) ? $security -> checknum( $_POST[ 'input_category' ] ) : 0 ;
	$input_teaserimage = ( isset( $_POST[ 'input_teaserimage' ] ) ) ? $security -> checknum( $_POST[ 'input_teaserimage' ] ) : 0 ;
	$input_top = ( isset( $_POST[ 'input_top' ] ) ) ? $security -> checknum( $_POST[ 'input_top' ] ) : 0 ;
	$input_year = ( isset( $_POST[ 'input_year' ] ) ) ? $security -> checknum( $_POST[ 'input_year' ] ) : "" ;
	$input_month = ( isset( $_POST[ 'input_month' ] ) ) ? $security -> checknum( $_POST[ 'input_month' ] ) : "" ;
	$input_day = ( isset( $_POST[ 'input_day' ] ) ) ? $security -> checknum( $_POST[ 'input_day' ] ) : "" ;
	$input_hour = ( isset( $_POST[ 'input_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_hour' ] ) : "" ;
	$input_minute = ( isset( $_POST[ 'input_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_minute' ] ) : "" ;
	$input_second = ( isset( $_POST[ 'input_second' ] ) ) ? $security -> checknum( $_POST[ 'input_second' ] ) : "" ;
	$input_now = ( isset( $_POST[ 'input_now' ] ) ) ? $security -> checknum( $_POST[ 'input_now' ] ) : "" ;
	$input_expire_year = ( isset( $_POST[ 'input_expire_year' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_year' ] ) : "" ;
	$input_expire_month = ( isset( $_POST[ 'input_expire_month' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_month' ] ) : "" ;
	$input_expire_day = ( isset( $_POST[ 'input_expire_day' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_day' ] ) : "" ;
	$input_expire_hour = ( isset( $_POST[ 'input_expire_hour' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_hour' ] ) : "" ;
	$input_expire_minute = ( isset( $_POST[ 'input_expire_minute' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_minute' ] ) : "" ;
	$input_expire_second = ( isset( $_POST[ 'input_expire_second' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_second' ] ) : "" ;
	$input_expire_never = ( isset( $_POST[ 'input_expire_never' ] ) ) ? $security -> checknum( $_POST[ 'input_expire_never' ] ) : "" ;
	$input_file_name = ( isset( $_POST[ 'input_file_name' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_name' ] ) : "" ;
	$input_file_seo = ( isset( $_POST[ 'input_file_seo' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_seo' ] ) : "" ;
	$input_file_version = ( isset( $_POST[ 'input_file_version' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_version' ] ) : "" ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_description' ] ) : "" ;
	$input_file_keywords = ( isset( $_POST[ 'input_file_keywords' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_keywords' ] ) : "" ;
	$input_file_smalldescription = ( isset( $_POST[ 'input_file_smalldescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_smalldescription' ] ) : "" ;
	$input_file_longdescription = ( isset( $_POST[ 'input_file_longdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_longdescription' ] ) : "" ;
	$input_file_size = ( isset( $_POST[ 'input_file_size' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_size' ] ) : "" ;
	$input_file_cost = ( isset( $_POST[ 'input_file_cost' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_cost' ] ) : "" ;
	$input_file_company = ( isset( $_POST[ 'input_file_company' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_company' ] ) : "" ;
	$input_file_homepage = ( isset( $_POST[ 'input_file_homepage' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_homepage' ] ) : "" ;
	$input_file_email = ( isset( $_POST[ 'input_file_email' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_email' ] ) : "" ;
	$input_file_pad = ( isset( $_POST[ 'input_file_pad' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_pad' ] ) : "" ;
	$input_file_language = ( isset( $_POST[ 'input_file_language' ] ) ) ? $security -> checknum( $_POST[ 'input_file_language' ] ) : "" ;
	$input_file_os = ( isset( $_POST[ 'input_file_os' ] ) ) ? $security -> checkvararray( $_POST[ 'input_file_os' ] ) : array() ;
	$input_file_changeinfo = ( isset( $_POST[ 'input_file_agreement' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_changeinfo' ] ) : "" ;
	$input_file_agreement = ( isset( $_POST[ 'input_file_agreement' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_agreement' ] ) : "" ;
	$input_primary_url = ( isset( $_POST[ 'input_primary_url' ] ) ) ? $security -> checkvar( $_POST[ 'input_primary_url' ] ) : "" ;
	$input_secondary_url = ( isset( $_POST[ 'input_secondary_url' ] ) ) ? $security -> checkvar( $_POST[ 'input_secondary_url' ] ) : "" ;
	$input_html = ( isset( $_POST[ 'input_html' ] ) ) ? $security -> checknum( $_POST[ 'input_html' ] ) : "" ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : "" ;
	$input_blockcode = ( isset( $_POST[ 'input_blockcode' ] ) ) ? $security -> checknum( $_POST[ 'input_blockcode' ] ) : "" ;
	$input_allow_comments = ( isset( $_POST[ 'input_allow_comments' ] ) ) ? $security -> checknum( $_POST[ 'input_allow_comments' ] ) : 0 ;
	$input_frontpage = ( isset( $_POST[ 'input_frontpage' ] ) ) ? $security -> checknum( $_POST[ 'input_frontpage' ] ) : 0 ;
	$input_url_tag = ( isset( $_POST[ 'input_url_tag' ] ) ) ? $security -> checknum( $_POST[ 'input_url_tag' ] ) : "" ;
	$input_url_get = ( isset( $_POST[ 'input_url_get' ] ) ) ? $security -> checknum( $_POST[ 'input_url_get' ] ) : "" ;
	$input_status = ( isset( $_POST[ 'input_status' ] ) ) ? $security -> checknum( $_POST[ 'input_status' ] ) : 0 ;
	$input_password = ( isset( $_POST[ 'input_password' ] ) ) ? $security -> checkvar( $_POST[ 'input_password' ] ) : "" ;
	$input_fields = ( isset( $_POST[ 'input_fields' ] ) ) ? $security -> checkvararray( $_POST[ 'input_fields' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_dopreview = ( isset( $_POST[ 'input_dopreview' ] ) ) ? $security -> checkvar( $_POST[ 'input_dopreview' ] ) : "" ;
	$input_doupload = ( isset( $_POST[ 'input_doupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doupload' ] ) : "" ;
	$input_doteaserupload = ( isset( $_POST[ 'input_doteaserupload' ] ) ) ? $security -> checkvar( $_POST[ 'input_doteaserupload' ] ) : "" ;
	$input_file_title = ( isset( $_POST[ 'input_file_title' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_title' ] ) : "" ;
	$input_file_description = ( isset( $_POST[ 'input_file_description' ] ) ) ? $security -> checkvar( $_POST[ 'input_file_description' ] ) : "" ;
	$input_dofileremove = ( isset( $_POST[ 'input_dofileremove' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileremove' ] ) : "" ;
	$input_dofileedit = ( isset( $_POST[ 'input_dofileedit' ] ) ) ? $security -> checkvar( $_POST[ 'input_dofileedit' ] ) : "" ;
	$input_doeditfile = ( isset( $_POST[ 'input_doeditfile' ] ) ) ? $security -> checkvar( $_POST[ 'input_doeditfile' ] ) : "" ;
	$input_edittitle = ( isset( $_POST[ 'input_edittitle' ] ) ) ? $security -> checkvar( $_POST[ 'input_edittitle' ] ) : "" ;
	$input_editdescription = ( isset( $_POST[ 'input_editdescription' ] ) ) ? $security -> checkvar( $_POST[ 'input_editdescription' ] ) : "" ;
	$input_editid = ( isset( $_POST[ 'input_editid' ] ) ) ? $security -> checknum( $_POST[ 'input_editid' ] ) : "" ;
	$input_dospellcheck = ( isset( $_POST[ 'input_dospellcheck' ] ) ) ? $security -> checkvar( $_POST[ 'input_dospellcheck' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	
	if( ( $system -> adminhashget() != $input_security_hash ) and( $preferences[ 'website_subsessions_admin' ] ) )
	{
		$html -> login( $words_files[ 'ERROR' ], $words_files[ 'INVALID_SESSION' ], "index.php" );
		exit;
	}
	
	$notice = "";
	
	if( $input_doupload )
	{
		$file_name = ( isset( $_FILES[ 'input_file' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_file' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_file' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_file' ][ 'tmp_name' ] : "" ;
		$file_size = ( isset( $_FILES[ 'input_file' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_file' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_file' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_file' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$notice = $words_files[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_files[ 'BYTES' ];
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$notice = $words_files[ 'FILETYPE_INVALID' ];
			}
		}
		else
		{
			$notice = $words_files[ 'FILETYPE_UNKNOWN' ];
		}
		
		if( !$tmp_name )
		{
			$notice = $words_files[ 'FILE_EMPTY' ];
		}
		
		if( !$notice )
		{
			$file = @fopen( $tmp_name, "r" );
			
			if( $file )
			{
				$binary = fread( $file, filesize( $tmp_name ) );
				
				if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
				{
					if( $preferences[ 'files_image_width' ] )
					{
						$binary = $system -> resizeimage( $binary, $file_type, $preferences[ 'files_image_width' ], $preferences[ 'files_image_brandtext' ], $preferences[ 'files_image_brandcolor' ] );
						$file_size = strlen( $binary );
					}
					
					$thumb_image = $system -> resizeimage( $binary, $file_type, $preferences[ 'files_image_thumbwidth' ], "", "" );
					$thumb_size = strlen( $thumb_image );
					$thumb_image = $database -> dbescape( $thumb_image );
				}
				else
				{
					$thumb_image = "";
					$thumb_size = 0;
				}
				
				$binary = $database -> dbescape( $binary );
				fclose( $file );
				
				if( !$input_file_title )
				{
					$input_file_title = $file_name;
				}
				
				if( !$input_file_description )
				{
					$input_file_description = $words_files[ 'NO_DESCRIPTION' ];
				}
				
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesfiles (filefile_id, filefile_author, filefile_filename, filefile_title, filefile_description, filefile_mime, filefile_size, filefile_binary, filefile_thumbsize, filefile_thumbimage, filefile_inuse, filefile_file, filefile_date, filefile_views, filefile_activity, filefile_postip, filefile_editip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $input_file_title . "', '" . $input_file_description . "', '" . $file_type . "', '" . $file_size . "', '" . $binary . "', '" . $thumb_size . "', '" . $thumb_image . "', '0', '0', now(), '0', now(), '" . $ipaddr . "', '" . $ipaddr . "')" );
				$notice = $words_files[ 'UPLOAD_SUCCESSFULLY' ];
			}
		}
	}
	
	if( $input_doteaserupload )
	{
		$file_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) ? $security -> checkvar( strtolower( $_FILES[ 'input_teaserfile' ][ 'name' ] ) ) : "" ;
		$tmp_name = ( isset( $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] ) ) ? $_FILES[ 'input_teaserfile' ][ 'tmp_name' ] : "" ;
		$file_size = ( isset( $_FILES[ 'input_teaserfile' ][ 'size' ] ) ) ? $security -> checknum( $_FILES[ 'input_teaserfile' ][ 'size' ] ) : "" ;
		$file_type = ( isset( $_FILES[ 'input_teaserfile' ][ 'type' ] ) ) ? $security -> checkvar( $_FILES[ 'input_teaserfile' ][ 'type' ] ) : "" ;
		$query = $database -> dbquery( "SELECT filetype_adminsize, filetype_extension FROM " . DB_PREFIX . "esselbach_ct_filetypes WHERE filetype_mime = '" . $file_type . "' AND filetype_isimage = '1'" );
		
		if( $database -> dbrows( $query ) )
		{
			list( $file_allowedsize, $file_extension ) = $database -> dbrow( $query );
			
			if( $file_size > $file_allowedsize )
			{
				$notice = $words_files[ 'FILE_TOO_LARGE' ] . " " . $file_allowedsize . " " . $words_files[ 'BYTES' ];
			}
			
			if( !preg_match( "/" . $file_extension . "/i", $file_name ) )
			{
				$notice = $words_files[ 'FILETYPE_INVALID' ];
			}
		}
		else
		{
			$notice = $words_files[ 'FILETYPE_NOT_ALLOWED_IMAGE' ];
		}
		
		if( !$tmp_name )
		{
			$notice = $words_files[ 'FILE_EMPTY' ];
		}
		
		$file = @fopen( $tmp_name, "r" );
		
		if( $file and !$notice )
		{
			$binary = fread( $file, filesize( $tmp_name ) );
			
			if( ( $file_type == "image/png" or $file_type == "image/pjpeg" or $file_type == "image/jpeg" or $file_type == "image/gif" ) and function_exists( "imagecreatefromstring" ) )
			{
				if( $preferences[ 'files_image_teaserwidth' ] )
				{
					$teaserwidth = $preferences[ 'files_image_teaserwidth' ];
				}
				else
				{
					$teaserwidth = 20;
				}
				
				$teaser_image = $system -> resizeimage( $binary, $file_type, $teaserwidth, "", "" );
				$teaser_size = strlen( $teaser_image );
				$teaser_image = $database -> dbescape( $teaser_image );
			}
			else
			{
				$teaser_size = $file_size;
				$teaser_image = $database -> dbescape( $binary );
			}
			
			fclose( $file );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesteaserimages (fileteaserimage_id, fileteaserimage_author, fileteaserimage_filename, fileteaserimage_mime, fileteaserimage_size, fileteaserimage_binary, fileteaserimage_default, fileteaserimage_file, fileteaserimage_ip) VALUES (NULL, '" . $login_username . "', '" . $file_name . "', '" . $file_type . "', '" . $teaser_size . "', '" . $teaser_image . "', '0', '0', '" . $ipaddr . "')" );
			$notice = $words_files[ 'TEASER_IMAGE_ADDED' ];
		}
	}
	
	if( $input_dofileremove )
	{
		$input_file = explode( "#", $input_dofileremove );
		$input_file = $security -> checknum( $input_file[ 1 ] );
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_filesfiles WHERE filefile_author = '" . $login_username . "' AND filefile_id = '" . $input_file . "'" );
		$notice = $words_files[ 'FILE_REMOVED' ];
	}
	
	if( !$notice )
	{
		if( !$input_file_name )
		{
			$notice = $words_files[ 'FILE_NO_NAME' ];
		}
		
		if( !$input_file_smalldescription )
		{
			$notice = $words_files[ 'FILE_NO_SMALLDESCRIPTION' ];
		}
		
		if( $input_file_pad )
		{
			$input_file_pad = str_replace( "..", "", $input_file_pad );
			
			if( function_exists( "curl_init" ) )
			{
				$pad = curl_init( $input_file_pad );
				curl_setopt( $pad, CURLOPT_RETURNTRANSFER, 1 );
				$data = curl_exec( $pad );
				curl_close( $pad );
			}
			else
			{
				$data = @fopen( $input_file_pad, "r" );
			}
			
			
			if( !$data )
			{
				$notice = $words_files[ 'INVALID_PAD_SOURCE' ];
			}
		}
		
		if( !$input_primary_url )
		{
			$notice = $words_files[ 'FILE_NO_PRIMARY_URL' ];
		}
		
		if( $preferences[ 'files_start_expire_date' ] )
		{
			if( !checkdate( $input_month, $input_day, $input_year ) or !checkdate( $input_expire_month, $input_expire_day, $input_expire_year ) )
			{
				$notice = $words_files[ 'INVALID_DATE' ];
			}
		}
		
		if( ( $input_status == 3 ) and( !$input_password ) )
		{
			$notice = $words_files[ 'NO_PASSWORD' ];
		}
	}
	
	if( $input_dofileedit )
	{
		$notice = "";
	}
	
	if( $input_doeditfile )
	{
		if( !$input_edittitle )
		{
			$query = dbquery( "SELECT filefile_filename FROM " . DB_PREFIX . "esselbach_ct_filesfiles WHERE filefile_id = '" . $input_editid . "'" );
			list( $input_edittitle ) = $database -> dbquery( $query );
			$input_edittitle = $database -> dbescape( $input_edittitle );
		}
		
		if( !$input_editdescription )
		{
			$input_editdescription = $words_files[ 'NO_DESCRIPTION' ];
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filesfiles SET filefile_title = '" . $input_edittitle . "', filefile_description = '" . $input_editdescription . "', filefile_editip = '" . $ipaddr . "' WHERE filefile_author = '" . $login_username . "' AND filefile_id = '" . $input_editid . "'" );
		$notice = $words_files[ 'DESCRIPTION_CHANGED' ];
	}
	
	if( !$input_file_description )
	{
		$input_file_description = $system -> description( $input_file_smalldescription );
	}
	
	if( !$input_file_keywords )
	{
		$input_file_keywords = $system -> keywords( $input_file_smalldescription );
	}
	
	if( $input_dospellcheck )
	{
		if( $dictionary = @pspell_new( $preferences[ 'website_spellchecker' ] ) )
		{
			$words_array = explode( " ", $input_file_smalldescription . "\n" . $input_file_longdescription );
			$input_page_spelling = "";
			$input_spell_errors = 0;
			
			foreach( $words_array as $word )
			{
				if( pspell_check( $dictionary, $word ) )
				{
					$input_page_spelling .= $word . " ";
				}
				else
				{
					$suggestions = implode( ", ", pspell_suggest( $dictionary, $word ) );
					( $suggestions ) ? $suggestions = $words_files[ 'SUGGESTIONS' ] . ": " . $suggestions : $suggestions = $words_files[ 'NO_SUGGESTIONS' ];
					$input_page_spelling .= "<span style=\"background-color: rgb(235, 15, 20); font-weight:bold;\" title=\"" . $suggestions . "\"><strong>" . $word . "</strong></span> ";
					$input_spell_errors++;
				}
			}
			
			$notice = $words_files[ 'THE_SPELL_CHECKER_FOUND' ] . " " . $input_spell_errors . " " . $words_files[ 'ERRORS' ] . ":<br /><br />" . $input_page_spelling;
		}
	}
	
	if( ( $notice ) or( $input_dopreview ) or( $input_dofileedit ) )
	{
		AdminCheckPADUpdates( $notice );
	}
	else
	{
		$seo_url = ( $preferences[ 'website_mod_rewrite' ] ) ? "" : "contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] ;
		if( $preferences[ 'files_undo' ] )
		{
			$query = $database -> dbquery( "SELECT file_author, file_name, file_version, file_seo, file_rawsmalldescription, file_rawlongdescription, file_description, file_keywords, file_size, file_cost, file_company, file_homepage, file_email, file_language, file_os, file_changeinfo, file_agreement, file_fields, file_startdate, file_expiredate, file_neverexpire, file_editadmin FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_id = '" . $input_id . "'" );
			list( $old_author, $old_name, $old_version, $old_seo, $old_smalldescription, $old_longdescription, $old_description, $old_keywords, $old_size, $old_cost, $old_company, $old_homepage, $old_email, $old_language, $old_os, $old_changeinfo, $old_agreement, $old_fields, $old_startdate, $old_expiredate, $old_neverexpire, $old_editadmin ) = $database -> dbrow( $query );
			$old_author = $database -> dbescape( $old_author );
			$old_name = $database -> dbescape( $old_name );
			$old_version = $database -> dbescape( $old_version );
			$old_seo = $database -> dbescape( $old_seo );
			$old_smalldescription = $database -> dbescape( $old_smalldescription );
			$old_longdescription = $database -> dbescape( $old_longdescription );
			$old_description = $database -> dbescape( $old_description );
			$old_keywords = $database -> dbescape( $old_keywords );
			$old_size = $database -> dbescape( $old_size );
			$old_cost = $database -> dbescape( $old_cost );
			$old_company = $database -> dbescape( $old_company );
			$old_homepage = $database -> dbescape( $old_homepage );
			$old_email = $database -> dbescape( $old_email );
			$old_language = $database -> dbescape( $old_language );
			$old_os = $database -> dbescape( $old_os );
			$old_changeinfo = $database -> dbescape( $old_changeinfo );
			$old_agreement = $database -> dbescape( $old_agreement );
			$old_startdate = $database -> dbescape( $old_startdate );
			$old_expiredate = $database -> dbescape( $old_expiredate );
			$old_neverexpire = $database -> dbescape( $old_neverexpire );
			$old_editadmin = $database -> dbescape( $old_editadmin );
			$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_filesundo (fileundo_id, fileundo_file, fileundo_author, fileundo_name, fileundo_version, fileundo_seo, fileundo_smalldescription, fileundo_longdescription, fileundo_description, fileundo_keywords, fileundo_size, fileundo_cost, fileundo_company, fileundo_homepage, fileundo_email, fileundo_language, fileundo_os, fileundo_changeinfo, fileundo_agreement, fileundo_fields, fileundo_date, fileundo_startdate, fileundo_expiredate, fileundo_neverexpire, fileundo_editip, fileundo_editadmin, fileundo_editreason) VALUES (NULL, '" . $input_id . "', '" . $old_author . "', '" . $old_name . "', '" . $old_version . "', '" . $old_seo . "', '" . $old_smalldescription . "', '" . $old_longdescription . "', '" . $old_description . "', '" . $old_keywords . "', '" . $old_size . "', '" . $old_cost . "', '" . $old_company . "', '" . $old_homepage . "', '" . $old_email . "', '" . $old_language . "', '" . $old_os . "', '" . $old_changeinfo . "', '" . $old_agreement . "', '" . $old_fields . "', now(), '" . $old_startdate . "', '" . $old_expiredate . "', '" . $old_neverexpire . "', '" . $ipaddr . "', '" . $old_editadmin . "', '" . $words_files[ 'PAD_UPDATE' ] . "')" );
		}
		
		if( is_array( $input_file_os ) )
		{
			$input_file_os_list = implode( ",", $input_file_os );
		}
		else
		{
			$input_file_os_list = "";
		}
		
		if( is_array( $input_fields ) )
		{
			$input_fields_encoded = base64_encode( $system -> stripthis( $input_fields[ 0 ] ) );
			
			for( $i = 1; $i < 24; $i++ )
			{
				$input_fields_encoded .= "|";
				
				if( isset( $input_fields[ $i ] ) )
				{
					$input_fields_encoded .= base64_encode( $system -> stripthis( $input_fields[ $i ] ) );
				}
			}
		}
		else
		{
			$input_fields_encoded = "";
		}
		
		$input_fields = "";
		
		if ( $input_blockcode )
		{
			if ( $input_url_tag )
			{
				$input_file_smalldescription = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_file_smalldescription );
				$input_file_longdescription = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_file_longdescription );	
			}
				
			if ( $input_url_get )
			{
				$input_file_smalldescription = $system -> geturltitles( $input_file_smalldescription );
				$input_file_longdescription = $system -> geturltitles( $input_file_longdescription );
			}
		}
		
		$input_file_smalldescription_parsed = stripslashes( $input_file_smalldescription );
		$input_file_longdescription_parsed = stripslashes( $input_file_longdescription );
		
		if( !$input_html )
		{
			$input_file_smalldescription_parsed = $system -> dechomp( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> dechomp( $input_file_longdescription_parsed );
		}
		else
		{
			$input_file_smalldescription_parsed = $system -> scriptex( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> scriptex( $input_file_longdescription_parsed );
		}
		
		if( $input_smilies )
		{
			$input_file_smalldescription_parsed = $system -> smilies( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> smilies( $input_file_longdescription_parsed );
		}
		
		if( $input_blockcode )
		{
			$input_file_smalldescription_parsed = $system -> code( $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = $system -> code( $input_file_longdescription_parsed );
			$input_file_smalldescription_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=files&amp;action=file&amp;id=\\1\">\\2</a>", $input_file_smalldescription_parsed );
			$input_file_smalldescription_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=file&amp;action=files&amp;id=\\1\" alt=\"\" />", $input_file_smalldescription_parsed );
			$input_file_smalldescription_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_files[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=files&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_file_smalldescription_parsed );
			$input_file_longdescription_parsed = eregi_replace( "\\[attachment=([^\\[]+)\\]([^\\[]*)\\[/attachment\\]", "<a href=\"contentteller.php?ct=files&amp;action=file&amp;id=\\1\">\\2</a>", $input_file_longdescription_parsed );
			$input_file_longdescription_parsed = eregi_replace( "\\[fullimage=([^\\[]+)\\]", "<img src=\"contentteller.php?ct=files&amp;action=file&amp;id=\\1\" alt=\"\" />", $input_file_longdescription_parsed );
			$input_file_longdescription_parsed = eregi_replace( "\\[thumb=([^\\[]+)\\]", "<a href=\"" . $seo_url . "files" . $preferences[ 'param_action' ] . "image" . $preferences[ 'param_page' ] . "\\1.html\" title=\"" . $words_files[ 'CLICK_TO_ENLARGE' ] . "\"><img src=\"contentteller.php?ct=files&amp;action=thumb&amp;id=\\1\" class=\"thumb\" alt=\"\" /></a>", $input_file_longdescription_parsed );
		}
		
		$input_file_smalldescription_parsed = $database -> dbescape( $input_file_smalldescription_parsed );
		$input_file_longdescription_parsed = $database -> dbescape( $input_file_longdescription_parsed );
		
		if( $preferences[ 'files_start_expire_date' ] )
		{
			if( $input_now )
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime() );
			}
			else
			{
				$input_startdate = date( "Y-m-d H:i:s", mktime( $input_hour, $input_minute, $input_second, $input_month, $input_day, $input_year ) );
			}
			
			$input_expiredate = date( "Y-m-d H:i:s", mktime( $input_expire_hour, $input_expire_minute, $input_expire_second, $input_expire_month, $input_expire_day, $input_expire_year ) );
		}
		
		if( !$input_file_seo )
		{
			$input_file_seo = $input_file_title;
		}
		
		$input_file_seo = $system -> doseo( $input_file_seo );
		$query = $database -> dbquery( "SELECT COUNT(file_id) FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $input_file_seo . "'" );
		list( $seo_stories ) = $database -> dbrow( $query );
		
		if( $seo_stories > 1 )
		{
			$input_file_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
		}
		
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_files SET file_website = '" . $input_website . "', file_category = '" . $input_category . "', file_author = '" . $login_username . "', file_name = '" . $input_file_name . "', file_version = '" . $input_file_version . "', file_seo = '" . $input_file_seo . "', file_rawsmalldescription = '" . $input_file_smalldescription . "', file_smalldescription = '" . $input_file_smalldescription_parsed . "', file_rawlongdescription = '" . $input_file_longdescription . "', file_longdescription = '" . $input_file_longdescription_parsed . "', file_description = '" . $input_file_description . "', file_keywords = '" . $input_file_keywords . "', file_size = '" . $input_file_size . "', file_cost = '" . $input_file_cost . "', file_company = '" . $input_file_company . "', file_homepage = '" . $input_file_homepage . "', file_email = '" . $input_file_email . "', file_language = '" . $input_file_language . "', file_os = '" . $input_file_os_list . "', file_changeinfo = '" . $input_file_changeinfo . "', file_agreement = '" . $input_file_agreement . "', file_teaser = '" . $input_teaserimage . "', file_allowcomments = '" . $input_allow_comments . "', file_frontpage = '" . $input_frontpage . "', file_fields = '" . $input_fields_encoded . "', file_html = '" . $input_html . "', file_smilies = '" . $input_smilies . "', file_code = '" . $input_blockcode . "', file_status = '" . $input_status . "', file_password = '" . $input_password . "', file_date = now(), file_sticky = '" . $input_top . "', file_editip = '" . $ipaddr . "', file_editadmin = '" . $login_username . "' WHERE file_id = '" . $input_id . "'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filesdownloads SET filedownload_url = '" . $input_primary_url . "', filedownload_editip = '" . $ipaddr . "', filedownload_editadmin = '" . $login_username . "' WHERE filedownload_file = '" . $input_id . "' AND filedownload_num = '1'" );
		
		if( $input_secondary_url )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filesdownloads SET filedownload_url = '" . $input_secondary_url . "', filedownload_editip = '" . $ipaddr . "', filedownload_editadmin = '" . $login_username . "' WHERE filedownload_file = '" . $input_id . "' AND filedownload_num = '2'" );
		}
		
		if( $preferences[ 'files_start_expire_date' ] )
		{
			$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_files SET file_startdate = '" . $input_startdate . "', file_expiredate = '" . $input_expiredate . "', file_neverexpire = '" . $input_expire_never . "' WHERE file_id = '" . $input_id . "'" );
		}
		
		if( $preferences[ 'files_allow_subscriptions' ] )
		{
			$main_templates = $templates -> preparetemplates( "'files_subscribe_email_subject','files_subscribe_email_body'", $preferences[ 'current_theme' ] );
			$query = $database -> dbquery( "SELECT filesubscriber_loginname FROM " . DB_PREFIX . "esselbach_ct_filessubscribers WHERE filesubscriber_fileid = '" . $input_id . "'" );
			
			if( $database -> dbrows( $query ) )
			{
				while( list( $filesubscriber_loginname ) = $database -> dbrow( $query ) )
				{
					$mail_users[ ] = "'" . $database -> dbescape( $filesubscriber_loginname ) . "'";
				}
				
				$all_users = implode( ",", $mail_users );
				$mail_emails = $uwrapper -> getemails( $all_users );
				
				foreach( $mail_emails as $email )
				{
					$insert[ 'page_name' ] = $preferences[ 'website_name' ];
					$insert[ 'file_name' ] = stripslashes( $input_file_name );
					$insert[ 'file_version' ] = stripslashes( $input_file_version );
					$insert[ 'file_changeinfo' ] = stripslashes( $input_file_changeinfo );
					$insert[ 'download_siteadmin' ] = $preferences[ 'user_registration_adminname' ];
					$insert[ 'download_url' ] = $preferences[ 'website_url' ] . "/contentteller" . $preferences[ 'param_ext' ] . $preferences[ 'param_ct' ] . "files" . $preferences[ 'param_action' ] . "details" . $preferences[ 'param_page' ] . $input_file_seo . ".html";
					$header = $system -> mailheader( $preferences[ 'user_registration_adminname' ], $preferences[ 'user_registration_adminemail' ], $email, $email );
					$subject = $templates -> exectemplate( $main_templates[ 'files_subscribe_email_subject_html' ], $main_templates[ 'files_subscribe_email_subject_php' ], $insert );
					$body = $templates -> exectemplate( $main_templates[ 'files_subscribe_email_body_html' ], $main_templates[ 'files_subscribe_email_body_php' ], $insert );
					
					if( $preferences[ 'user_registration_emailserver' ] == "SMTP" )
					{
						$system -> smtpmail( $preferences[ 'user_registration_smtphost' ], $preferences[ 'user_registration_smtpport' ], $preferences[ 'user_registration_smtpusername' ], $preferences[ 'user_registration_smtppassword' ], $preferences[ 'user_registration_adminemail' ], $email, $subject, $body, $header );
					}
					else
					{
						mail( $email, $subject, $body, $header );
					}
				}
			}
		}
		
		$html -> login( $words_files[ 'CHECK_PAD_UPDATES' ], $words_files[ 'FILE_CHANGED' ], "index.php?action=checkpadupdates" );
	}
}
?>